module Metatheory

using Base.Meta
using Reexport
using TermInterface

macro log(args...)
    quote haskey(ENV, "MT_DEBUG") && @info($(args...)) end |> esc
end

@inline alwaystrue(x) = true

include("docstrings.jl")
include("utils.jl")
export @timer 
export @iftimer
export @timerewrite
export @matchable

include("Patterns.jl")
@reexport using .Patterns 

include("ematch_compiler.jl")
@reexport using .EMatchCompiler

include("matchers.jl")
include("Rules.jl")
@reexport using .Rules

include("Syntax.jl")
@reexport using .Syntax
include("EGraphs/EGraphs.jl")
@reexport using .EGraphs

include("Library.jl")
export Library

include("Rewriters.jl")
using .Rewriters
export Rewriters

function rewrite(expr, theory; order=:outer)
    if order == :inner 
        Fixpoint(Prewalk(Fixpoint(Chain(theory))))(expr)
    elseif order == :outer 
      Fixpoint(Postwalk(Fixpoint(Chain(theory))))(expr)
    end
end
export rewrite


end # module
